Nagios Business Process y Nagios Business Impact Analysis
(Procesos de negocio para Nagios y Anlisis de impacto de negocio para Nagios)
------------------------------------------------------------------------------

Este documento describe como instalarlos.
Si usas estos "AddOns" por primera vez asegurate de leer previamente el fichero README.

Requisitos
------------

1.  Debes tener instalado y operativo Nagios (http://www.nagios.org)
    o Icinga (http://www.icinga.org).
	
2.  Necesitas tener una de las siguientes opciones para posibilitarle
    a este software el acceso a la informacin actual de estado que 
	proporciona Nagios o Icinga.

2.1 NDOUTILS 
    (El "addon" NDOTILS - Nagios Data Output Utils - te permite pasar 
	informacin de estado y eventos de Nagios a una base de datos para
	procesarlos y analizarlos posteriormente). 
	ver: http://www.nagios.org/download/
	
2.2 IDOUTILS
    (similar que NDOUTILS pero para Icinga)
    ver: http://docs.icinga.org/latest/en/quickstart-idoutils.html

2.3 Como alternativa, puedes usar Merlin. Este requiere correr un demonio
    propio por separado y tambin una base de datos MySQL, pero hay gente
	que lo prefiere a NDOUTILS porque la estructura de tablas de Merlin
	es ms sencilla
    ver: http://www.op5.org/community/projects/merlin

2.4 Si no te gusta la sobrecarga que introduce una base de datos, 
    tambin puedes usar ndo2fs el cual escribe la misma informacin
	pero en el sistema de ficheros. (Pero ten en cuenta que ndo2fs
	usa tambin NDOUTILS. No te salvaras de instalar NDOUTILS solo 
	de la sobrecarga de ejecutar una base de datos).
    ver: http://www.pnp4nagios.org/ndo2fs/start

2.5 mk_livestatus
    Este "backend" es muy sencillo. No necesita NDOUTILS, ni una
	base de datos, ni tampoco almacenamiento en ficheros ni en ningn
	otro sitio porque directamente obtiene la informacin de la 
	estructura de memoria interna de Nagios o Icinga.
	Necesitas al menos la versin 1.1.2 de mk_livestatus.
    ver: http://mathias-kettner.de/checkmk_livestatus.html

2.6 Icinga-API
    Si tienes funcionando el nuevo Interface Web de Icinga
    (http://docs.icinga.org/latest/en/icinga-web-scratch.html),
	existe la posibilidad de obtener la informacin de estado de la 
	API HTTP/JSON de Icinga.
    Necesitas al menos Icinga-Web 1.0.3
    Pero ten en cuenta que genera conexiones HTTP adicionales y
	ejecuta scripts PHP adicionales para estas. Este modo es mucho
	ms lento que los dems!

		
3.  Necesitas un servidor web instalado, describimos la configuracin para Apache.

4.  Es necesario Perl > 5.8.

5.  Debe estar instalado el mdulo Perl CGI::Simple 
    Si no ests seguro si est instalado escribe el comando
    perl -e "use CGI::Simple" && echo ok
    esto saca por pantalla "ok" si el mdulo est instalado e incluido en la
    ruta por defecto INC, y d un error si no es as.
	Es posible que tu distribucin de Linux proporcione este como un 
	paquete llamado "libcgi-simple-perl" o similar.

6.  Debe estar instalado el mdulo Perl DBI 
    Si no ests seguro si est instalado escribe
	perl -e "use DBI" && echo ok

7.  Debe estar instalado el mdulo Perl JSON::XS
    Si no ests seguro si est instalado escribe
	perl -e "use JSON::XS" && echo ok
	Es posible que tu distribucin de Linux proporcione este como un 
	paquete llamado "libjson-perl" o similar.
 
	
Instalar
--------

Como root.
Extraer el fichero bajado
		tar xvzf nagios-business-process-addon-<VERSION>.tar.gz
		cd nagios-business-process-addon-<VERSION>

Si usas Nagios. Para instalarlo en la ruta por defecto (/usr/local/nagiosbp/)
        escribe
		./configure

Si usas Icinga. Para instalarlo en la ruta por defecto (/usr/local/nagiosbp/)
        escribe
		./configure --with-nagcgiurl=/icinga/cgi-bin --with-naghtmurl=/icinga --with-nagetc=/usr/local/icinga/etc/ --with-apache-authname="Icinga Access"
		
Si quieres instalarlo en otro sitio o si tu Nagios o Icinga no estn instalados
en la ruta por defecto (/usr/local/nagios/ o /usr/local/icinga/), 
puedes ejecutar configure con parmetros diferentes, ver la ayuda con
		./configure --help
para ms detalles
Al final, se listan todos los parmetros importantes. Si estn bien escribe
		make install
para instalar Nagios Business Process AddOns
		

Apache necesita procesar los nuevos ficheros de configuracin. Por lo
tanto un fichero nagiosbp.conf se habr creado en tu directorio conf.d
Es un fichero por defecto, con la configuracin habitual de los host
virtuales de Apache. Si no es lo que quieres, puedes copiar el contenido
del fichero nagiosbp.conf en la seccin correspondiente de Host Virtual
de tu fichero httpd.conf y borrar nagiosbp.conf posteriormente.
Otra posibilidad es instalar el fichero en otra ruta al ejecutar configure
por ejemplo con:
		./configure --with-httpd-conf=/usr/local/nagiosbp/etc/apache-conf.d/
y despus aadir una sentencia include en la seccin de Apache para el
correspondiente Host virtual
		Include /usr/local/nagiosbp/etc/apache-conf.d/nagiosbp.conf

Relativo a las directivas de "AuthName" (hay dos) en dicho fichero:
asegrate de que son exactamente las mismas que en el fichero de 
configuracin de Nagios o Icinga (conf.d/nagios.conf o conf.d/icinga.conf)
Si no es as el interface Web te preguntar dos veces por tu usuario
y contrasea, una vez para acceder a la pgina de Nagios o Icinga y otra
para acceder a la pgina de "Business Process AddOns".

Puedes pasarle el "AuthName" correcto al llamar a "configure" dandole
el parmetro adicional '--with-apache-authname' o editando posteriomente
el fichero conf.d/nagiosbp.conf .

				
Una vez realizados los cambios en la configuracin de Apache, escribimos
		apachectl configtest
De esta forma chequeamos la configuracin. Si la salida no da errores,
recargamos Apache.

Para "Nagios Business Impact Analysis", se crea automticamente una tarea
programada (cron) que elimina ficheros de sesiones antiguas. Normalmente 
se localiza en /etc/cron.d

Necesitars algunos enlaces (links) en Nagios o Icinga para que puedas usar
ambos AddOns 

Si ests usando Nagios edita /usr/local/nagios/share/side.html
		p.e. despus de la seccin
			  <tr>
			    <td width=13><img src="images/greendot.gif" width="13" height="14" name="statuswrl-dot"></td>
			    <td nowrap><a href="/nagios/cgi-bin/statuswrl.cgi?host=all" target="main" onMouseOver="switchdot('statuswrl-dot',1)" onMouseOut="switchdot('statuswrl-dot',0)" class="NavBarItem">3-D Status Map</a></td>
			  </tr>
		deberias insertas las lneas:  
			  <tr>
			    <td width=13><img src="images/greendot.gif" width="13" height="14" name="statuswrl-dot"></td>
			    <td nowrap><a href="/nagiosbp/cgi-bin/nagios-bp.cgi" target="main" onMouseOver="switchdot('statuswrl-dot',1)" onMouseOut="switchdot('statuswrl-dot',0)" class="NavBarItem">Business Process View</a></td>
			  </tr>
			  <tr>
			    <td width=13><img src="images/greendot.gif" width="13" height="14" name="statuswrl-dot"></td>
			    <td nowrap><a href="/nagiosbp/cgi-bin/nagios-bp.cgi?mode=bi" target="main" onMouseOver="switchdot('statuswrl-dot',1)" onMouseOut="switchdot('statuswrl-dot',0)" class="NavBarItem">Business Impact</a></td>
			  </tr>

Si ests usando Icinga con el GUI web clsico edita /usr/local/icinga/share/menu.html
		e. g. despus de la seccin
                        <li class="menuli_style1"><a href="/icinga/cgi-bin/extinfo.cgi?&type=7" target="main">Scheduling Queue</a></li>
		inserta las lneas:  
                        <li class="menuli_style2"><a href="/nagiosbp/cgi-bin/nagios-bp.cgi" target="main">Business Process View</a></li>
                        <li class="menuli_style1"><a href="/nagiosbp/cgi-bin/nagios-bp.cgi?mode=bi" target="main">Business Impact</a></li>

Como "Nagios Business Process AddOns" usa las hojas de estilo de Nagios
o Icinga el interface Web tiene el aspecto de Nagios cuando se instala
con Nagios y lo mismo cuando se instala con Icinga.					
Difieren en algunos pequeos detalles. Por lo tanto cuando uses Icinga
con el Interface Web clsico deberas insertar la siguiente lnea
		#nbp_foot_version, #nbp_foot_language, .nbp_text_small, .nbp_text_tiny { font-size:100%; }
en el fichero 'share/stylesheets/user.css'
De otra manera algunos elementos del Interface web se vern minsculos.

Si usas Icinga con el nuevo interface web necesitars el "Cronk" adicional
Puedes encontrarlo en el siguiente enlace
		http://nagiosbp.projects.nagiosforge.org/download.shtml
Por favor, sigue la documentacin de este para integrarlo con tu instalacin.

			  
Ahora es momento de tocar algunos archivos de configuracin.

Si ests ejecutando una base de datos (NDO, IDO o Merlin) crea un usuario
en tu base de datos.
El usuario necesita solo privilegios de 'select'.

Si ests corriendo NDO con ndo2fs, tienes que asegurarte que el usuario bajo
el que tu servidor web est corriendo tenga acceso de lectura a los ficheros
de salida de ndo2fs
Puedes por tanto querer aadir algo como
		-o UMASK=002
a la lnea
		ndo2fsParam
en el script de inicio de ndo2fs (normalmente se encuentra en /etc/init.d/ndo2fs)

Si ests corriendo mk_livestatus, tienes que asegurarte que el usuario bajo
el que tu servidor web est corriendo tenga acceso de lectura al socket unix
creado por mk_livestatus (por defecto: /usr/local/nagios/var/rw/live)

Cuando se use la API 'Icinga-API' como 'backend', hay que tener en cuenta:

La combinacin de la API de Icinga y 'Nagios Business Process AddOns' aun
no est en produccin en muchos sitios. Este es el 'backend' con ms
sobrecarga (son necesarios para obtener los datos una capa adicional de HTTP 
y otra de scripts PHP). Por lo tanto el rendimiento no es tn bueno como
en los otros 'backends'.

En resumen, si tienen una configuracin grande o necesitas un software que
est bien probado seguramente preferirs usarlo con una base de datos NDO o IDO
o con mk_livestatus.

Ahora mueve etc/ndo.cfg-sample a etc/ndo.cfg y edtalo

	cambia todos los parmetros de acuerdo a tu configuracin y, si
	ests usando una base de datos de 'backend', configura aqu 
	tambin el usuario de tu base de datos creado previamente.
	Si instalas todos los componentes con su configuracin y ruta 
	por defecto probablemente no tengas que cambiar demasiado.


Finalizaste la instalacin. Ahora tienes que configurar tus Procesos de negocio
(Business Processes) como se describe en el fichero README.

Acurdate especialmente de 'nagios-bp-check-ndo-connection.pl'

Traduccin: Javier Rubio.
