Nagios Business Process y Nagios Business Impact Analysis
(Procesos de Negocio para Nagios y Anlisis de impacto de negocio para Nagios)
------------------------------------------------------------------------------

El software y los documentos de este paquete han sido producidos por
Sparda-Datenverarbeitung eG, Nuernberg, Germany, Bernd Stroessenreuther 
<berny1@users.sourceforge.net> y estn disponibles para la comunidad bajo
las condiciones de la licencia "GNU General Public License Version 2". Ver LICENSE.


Breve visin general.
---------------------

El AddOn "Business Process View" obtiene los resultados de la salida de los
chequeos de Nagios almacenados en NDO o IDO "backends" (base de datos NDO, base
de datos IDO, ndo2fs, Merlin, mk_livestatus, Icinga-API) y genera estados agregados.
Como se asocian dichos estados se describe en uno o ms ficheros de configuracin.
Existe la posibilidad de hacer conjunciones y (and), o (or) y otras...
Un Proceso de Negocio (el cual se define como una formula) se puede usar como parte
de otro Proceso de Negocio. A partir de estos puedes generar una estructura jerrquica
que describa el estado de tu aplicacin.

El AddOn "Business Impact Analysis"  te permite simular problemas. Puedes configurar
manualmente el estado de cada componente de modo individual al estado que quieras
y ver que impacto tiene esto en tus aplicaciones.

Ayuda
-----
Si tienes problemas instalando o usando estos "AddOns", por favor
visita la pgina de soporte de nuestro sitio:
http://nagiosbp.projects.nagiosforge.org/support.shtml
En l podrs encontrar una FAQ y algunas listas de correo de ayuda.

Tambin puedes encontrar una comunidad de usuarios muy activa en
http://www.nagios-portal.org/
(esta solo es en alemn)


En que consiste?
-----------------
(un poco ms en detalle)

Ests ejecutando un montn de aplicaciones para tus clientes. (Uso la palabra
clientes porque como administrador de sistemas siempre tendrs clientes,
no importa si ellos son empleados o clientes de la compaa para la que trabajas).
Cada aplicacin necesita unos pocos o muchos componentes (como servidores Web, 
servidores de aplicaciones, DNS, servidores de correo, conexiones LAN o WAN ...)
para trabajar adecuadamente.
Hay componentes que se necesitan solo para una aplicacin, y hay componentes
que son importante para muchas aplicaciones (p.e.  servidor DNS)
Ya ests corriendo Nagios o Icinga para monitorizar todos estos componentes, supongo.
(De lo contrario no estaras pensando en un "AddOn" para Nagios)

Si eres el nico administrador de sistemas de tu empresa, probablemente
conocers todas tus aplicaciones muy bien, sabrs que aplicacin necesita que
componentes - entonces probablemente no necesites este "AddOn".
Si hay ms administradores, probablemente compartirs trabajos. Esto significa
que cada Administrador conoce bien  sus aplicaciones y las dems aplicaciones
no tanto.
Por lo tanto quiz encuentres interesante visualizar como funcionan todos
esto componentes juntos. Si uno de estos componentes falla, querrs ver en
una sencilla pgina que aplicaciones no estn disponibles para tus clientes
- en este caso: Instala este "addon":

Tiene dos modos:
1. Nagios Business Process View
   Muestra el estado actual de tus aplicaciones.
2. Nagios Business Impact Analysis
   Este es un modo de simulacin.
   Puedes configurar cada uno de tus componentes al estado que quieras.
   Por lo que si quieres saber: Que pasara si falla en este momento el
   servidor Web? Solo haz click en el estado de tu Servidor Web y establcelo
   a CRITICAL. Vuelve a la vista general de la pgina y mira que aplicaciones
   estn ahora en estado CRITICAL.

Los estados de servicios y equipos individuales definidos en Nagios o Icinga
se obtienen de"backend" NDO o IDO (NDO database, IDO database, ndo2fs, Merlin, 
mk_livestatus o Icinga-API).


Como funciona
-------------

Tienes uno o ms ficheros de configuracin en los cuales defines tus
aplicaciones. Defines que componentes son necesarios y como se relacionan.
Entonces editas el fichero etc/nagios-bp.conf
En este tienes que escribir algunas sencillas frmulas para definir los procesos
de negocio, p. e.:
		loadbalancers = loadbalancer1;System Health | loadbalancer2;System Health
		website_webserver1 = webserver1;HTTP & webserver1;HTTPD Slots
		
La primera cadena es el nombre que quieres dar al proceso de negocio.
En el lado izquierdo tiene una cadena con el formato (equipo;servicio)
		<hostname>;<servicename>

El ejemplo superior significa:
Tienes un cluster en balanceo de carga, si uno de ellos est en estado ok, la
aplicacin est disponible para el cliente. Por lo que defines una conjuncin
lgica "or" para tu Proceso de Negocio.

Si ests mirando si tu servidor web funciona correctamente, normalmente lo hars con
el chequeo HTTP y tambin con el chequeo "HTTPD Slots". Si ambos estn en estado
OK, sabrs que el servidor est funcionando bien. 
Por lo que pondremos ambos servicios juntos por medio de un conjuncin lgica "and"

El siguiente paso es, darle un nombre a cada Proceso de Negocio definido,
		display 0;loadbalancers;Loadbalancer Cluster
		display 0;website_webserver1;WebServer 1

El dgito despus de la palabra clave "display" es la clase de prioridad, en este
caso es visualizado en la vista del nivel superior.
0 significa: No visualizar
1, 2,...: Visualizar en la prioridad especificada.

Como puedes usar procesos de negocio individuales de nuevo en otros procesos, 
"display 0" es muy til si no quieres visualizar cada sub-proceso en el nivel 
superior de la vista.

Mostremos un ejemplo completo:

		internetconnection = internetconnection;Provider 1 | internetconnection;Provider 2
		display 0;internetconnection;Internet Connection
		
		loadbalancers = loadbalancer1;System Health | loadbalancer2;System Health
		display 0;loadbalancers;Loadbalancer Cluster
		
		dns = dns1;DNS | dns2;DNS | dns3;DNS
		display 0;dns;DNS Cluster
		
		website_webserver1 = webserver1;HTTP & webserver1;HTTPD Slots
		website_webserver2 = webserver2;HTTP & webserver2;HTTPD Slots
		website_webservers = website_webserver1 | website_webserver2
		website = internetconnection & loadbalancers & dns & website_webservers
		
		display 0;website_webserver1;WebServer 1
		display 0;website_webserver2;WebServer 2
		display 0;website_webservers;WebServer Cluster
		display 1;website;WebSite

Si estas lneas son las nicas en tu fichero de configuracin nagios-bp.conf, 
debera funcionar.
Has definido tu primer proceso de negocio, Felicidades!
Echa un vistazo a http://your-host/nagiosbp/cgi-bin/nagios-bp.cgi
(Asumo que tienes todos lo servicios y equipos definidos en fichero de configuracin
de Nagios o Icinga adaptados al ejemplo superior)

Ten mucho cuidado con los nombres!. El nombre de Equipo <hostname> y
el nombre de servicio <servicename> deben coincicidir exactamente tal
como estn definidos en Nagios/Icinga. Revisa que sean exactos, maysculas y
minsculas.

Puedes encontrar ms ejemplos en etc/nagios-bp.conf


Chequeo de Sintaxis
-------------------

Para asegurarte de que la sintaxis de tu fichero nagios-bp.conf es correcta, ejecuta
		bin/nagios-bp-consistency-check.pl
De esta forma se chequea tu fichero de configuracin por defecto nagios-bp.conf. Si
quieres chequear otro fichero
		bin/nagios-bp-consistency-check.pl <fichero>
		

Algunas claves ms
------------------

En la parte superior de la vista (http://your-host/nagiosbp/cgi-bin/nagios-bp.cgi)
la columna derecha est vaca de momento. Se puede usar para visualizar informacin
breve relacionada con el procesos de negocio. Esta puede ser cadenas estticas o 
dinmicas. P.e.: quieres visualizar, cuantos usuarios estn conectados actualmente
en tu "webshop" si defines un proceso de negocio "WebShop".
O quieres mostrar un comunicado breve, ...

Solo escribe un pequeo script que muestra la informacin que quieras (solo una linea
por salida "stdout") y entonces configura:

		external_info website;echo '<b>ATENCION:</b> WebServer 1 est en mantenimiento hoy,<br>WebServer2 es el nico en produccin'
o
		external_info website;/ruta/a/tu/script.sh

Quiz una pequea cadena de texto no sea suficiente para toda la informacin que quieres mostrar.
Entonces
		info_url website;/mas_info/website.html
o
		info_url website;http://algun.otro.sitio.com/mas_info/website.html

debera valerte. Solo enlaza con un Website con toda la informacin.
En la primera expresin, la pgina est en el equipo Nagios/Icinga.
En la segunda expresin, la pgina est en algn lugar en Internet
Si defines alguna info_url, aparecer un pequeo icono de informacin, al cual
pueden acceder con un click tus usuarios
Quiz quieras usarla para enlazar alguna documentacin de emergencia o similar.


Descripcin completa de la sintaxis
-----------------------------------

ATENCIN: El orden de las definiciones es importante!!
Si usas un proceso de negocio en la definicin de otro proceso de negocio 
(sub nivel), asegurate de que defines el proceso inferior (sub nivel) antes
de usarlo.

<bp_name> = <host>;<service> [& <host>;<service>]+

Los servicios que usan una conjuncin lgica "and": todos ellos son necesarios para que 
la aplicacin este disponible a los clientes.
O en otras palabras: si todos los servicios dados estn OK, el proceso de
negocio definido tendr un estado OK. Si al menos uno est en estado WARNING,
el proceso tendr el estado WARNING. Si al menos uno est en CRITICAL, el 
proceso estar en CRITICAL.
 
<bp_name> = <host>;<service> [| <host>;<service>]+

Los servicios que usan una conjuncin lgica "or": esto se usa a menudo si tienes
sistemas redundantes. Si uno de ellos est funcionando, la aplicacin est
disponible al cliente.
Si al menos un servicio est OK, el proceso tendr el estado OK.
Si todos lo servicios estn en estado CRITICAL y al  menos uno est en
estado WARNING, el proceso tendr el estado WARNING.
Solo si todos los servicios estn es estado CRITICAL, el proceso tambin
lo estar.

<bp_name> = <min_num> of: <host>;<service> + <host>;<service> [+ <host>;<service>]+

Usa la siguiente si tienes un nmero de servidores de aplicaciones ejecutando la
misma aplicacin y sabes que necesitas al menos <min_num> servidores activos
por razones de carga.
p.e.:
	appserver_cluster = 2 of: appserver1;WebShop + appserver2;WebShop + appserver3;WebShop + appserver4;WebShop
Si al menos 2 de los servicios dados estn en estado OK, el proceso est en estado OK.


<host>;Hoststatus

Tambin puedes usar los resultados de los chequeos de equipos de Nagios/Icinga en tus
procesos de negocios. 
En este caso deber usar la siguiente sintaxis.


En lugar de <host>;<service> tambin puedes usar <bp_name> , donde <bp_name>
es el nombre del un proceso de negocio que definiste ANTES.


display <x>;<bp_name>;<long_name>

El dgito x es la prioridad de los procesos. El proceso es visualizado en su
clase de prioridad en la vista de nivel superior.
0 significa: Este proceso no ser visualizado en la vista de nivel superior.
<long_name> es el nombre o descripcin usado cuando se visualiza el proceso.
(El usuario nunca ve <bp_name> en el GUI, siempre ver <long_name>)


external_info <bp_name>;<script>

Por cada proceso de negocio que no se defina con "display 0" puedes aadir
un script. El script debe imprimir una lnea en la salida estandar 'stdout'.
Esta lnea se muestra en la columna derecha de la vista de nivel superior
prxima a los procesos de negocio.


info_url <bp_name>;<url>

Por cada proceso de negocio que no es definido con "display 0" puedes aadir
una URL. Si defines una, un pequeo icono de informacin (letra blanca en fondo
azul) es mostrado prximo al proceso de negocio. Haciendo click en dicho icono 
irs a la URL.


template <bp_name>;<service_template>

Esta se usa solamente si "mapeas" Procesos de Negocio como servicios
de Nagios/Icinga (ver ms abajo "Representacin de Procesos de Negocio como
servicios de Nagios). 
Normalmente todos los procesos de negocio con "display" mayor que 0
tendrn la misma plantilla de servicio y todos los Procesos de Negocio
con "display" igual a 0 tendrn otra distinta.
Si quieres tener un Proceso de Negocio, por ejemplo, con un periodo de
notificacin (valor notification_period) distinto, debes definir una o ms
plantillas y darles su nombre aqu.


Chequear si todo funciona
-------------------------

Si hiciste todo lo descrito hasta este punto y realizaste la configuracin
como se describe en INSTALL, probablemente tendrs una nueva y bonita vista
en tu instalacin de Nagios. Si no, NO PASES DE ESTE PUNTO.
Recomiendo, que vuelvas atrs y soluciones los problemas primero, pongas a
funcionar tu instalacin y contines entonces con la siguiente parte (avanzada).

Si la pgina "Business Process View" no se visualiza, chequea el log de errores
de tu servidor web para localizar el problema. Quiz no se encuentra un mdulo
requerido de Perl o tienes un problema con los permisos de ficheros.
Si tienes SELinux o AppArmor, quiz estn evitando el acceso alalguno de los 
ficheros.
Quiz olvidaste reiniciar tu servidor web despus de hacer los cambios.

Lo siguiente para intentar localizar el problema es ejecutar un script
especialmente creado para ello:
	bin/nagios-bp-check-ndo-connection.pl
Ejecutalo como el usuario bajo el que corre Apache. Si tiene xito mostrar
una lista de todos los servicios conocido por tu "backend" NDO o IDO junto
con la informacin de estado y la ltima salida del plugin.
En caso de problemas obtendrs un mensaje de error que probablemente
te ser muy til para localizar donde est el problema.

Para verificar si el problema est en el servidor web on en el "Nagios Business
Process AddOn" puedes ejecutar:
	sbin/nagios-bp.cgi
desde la lnea de comandos. Realiza esto como usuario normal, no como root.
Si todo est correcto debera mostrar cdigo HTML en la salida estandar o, en
caso contrario, mensajes de error o advertencia.


Representacin de los procesos de negocio como Servicios de Nagios/Icinga
-------------------------------------------------------------------------

Ahora tienes una bonita pgina que visualiza la salud de algunas o todas 
tus aplicaciones en ese momento concreto.
Pero tienes dicha informacin para ese instante concreto. No puedes ver
como estaba hace una hora o hace un da. No tienes un histrico.
Y adems, no tienes notificaciones para el proceso de negocio entero, solo para los
componentes individuales.

La solucin es sencilla. Solo define cualquier proceso de negocio el mismo como
si fuera un servicio de Nagios. Nagios chequear el estado de estos servicios
regularmente, p.e.: cada minuto. Es este servicio puedes usar todas las
caractersticas de Nagios: notificaciones, estadsticas, historia, ...

Se incluye un sencillo script, que genera un fichero de configuracin de Nagios
adicional con todos los procesos de negocio como servicios.
Puedes encontrar el script en
		bin/bp_cfg2service_cfg.pl
Al ejecutar este script debera generarse un nuevo fichero
		services-bp.cfg
en el directorio etc de Nagios/Icinga (no el etc de Nagios Business Process AddOns)
No hagas ningn cambio a mano en este fichero! Si cambias tu proceso de negocio
posteriormente debers ejecutar este script de nuevo. Este generar un fichero 
services-bp.cfg actualizado y sobrescribir cualquier cambio que hagas en l.
	
El prximo paso es editar el fichero nagios.cfg o icinga.cfg (normalmente
/usr/local/nagios/etc/nagios.cfg o /usr/local/icinga/etc/icinga.cfg)
y aadir el nuevo fichero de configuracin aadiendo una nueva lnea como:
		cfg_file=/usr/local/nagios/etc/services-bp.cfg
o
		cfg_file=/usr/local/icinga/etc/services-bp.cfg

Adicionalmente necesitars dos nuevas platillas de servicios, dos nuevos hosts ficticios,
y dos nuevos comandos similares a los siguientes.
Por favor defnelos en otro fichero de configuracin de Nagios/Icinga, p.e. el servicio en 
services.cfg, el equipo en host.cfg y los comandos en commands.cfg
(No los definas en services-bp.cfg!!)

		define service{
		        name                            generic-bp-service
		        use                             generic-service
		        contact_groups                  nagios-admins
		        host_name                       business_processes
		        notification_period             none
		        max_check_attempts              1
		        register                        0
		}
			
		define service{
		        name                            generic-bp-detail-service
		        use                             generic-service
		        contact_groups                  nagios-admins
			host_name                       business_processes_detail
		        notification_period             none
		        max_check_attempts              1
		        normal_check_interval           5
		        retry_check_interval            1
		        register                        0
		}

		define host{
		        use                     generic-host
		        host_name               business_processes
		        alias                   Business Processe
		        address                 10.6.255.99             # dummy IP
		        contact_groups          nogroup
		        check_command           return_true
		}
		
		define host{
		        use                     generic-host
		        host_name               business_processes_detail
		        alias                   untergeordnete Business Processe
		        address                 10.6.255.99             # dummy IP
		        contact_groups          nogroup
		        check_command           return_true
		}

		define command{
		        command_name    check_bp_status
		        command_line    /usr/local/nagiosbp/libexec/check_bp_status.pl -b $ARG1$ -f $ARG2$
		}

		define command{
		        command_name    return_true
		        command_line    $USER1$/check_dummy 0
		}

Ahora recarga tu configuracin de Nagios/Icinga. Es todo.
Nagios ahora chequear los estados de todos los Procesos de Negocio regularmente.

Si te son interesantes solo los estados de los procesos de negocio de la vista
de nivel superior y no los estados de los subprocesos, usa
		bin/bp_cfg2service_cfg.pl -s 0
En este caso no necesitas la plantilla de servicio template generic-bp-detail-service y 
la plantilla de equipo template business_processes_detail

Los parmetros para este script se mostraran si escribes
		bin/bp_cfg2service_cfg.pl --help

Si ests usando estos nuevos servicios para generar alertas para problemas de
Procesos de Negocio enteros, puedes no querer informar a los mismos usuarios
o grupos para todos los procesos de negocio. Evidentemente, este seria el caso
si solo tienes una plantilla para todos ellos (como se describe arriba).

Por lo tanto para todos los procesos de negocio que quieras que usen alguna
otra plantilla que la plantilla por defecto, deberas aadir una lnea de la forma
		template <bp_name>;<service_template>
p.e. para nuestra plantilla
		template website;website-bp-service
a tu fichero etc/nagios-bp.conf. 

Esto significa, que el servicio representando el Proceso de Negocio del
website debera generarse con la plantilla website-bp-service.

Claro, en este caso necesitaras definir otra plantilla:

		define service{
		        name                            website-bp-service
		        use                             generic-bp-service
		        contact_groups                  website-admins
		        notification_period             24x7
		        register                        0
		}

Ejecuta de nuevo bin/bp_cfg2service_cfg.pl. Generar un fichero 
services-bp.cfg donde el servicio estar ahora definido referenciando a
esta nueva plantilla.
Recarga Nagios y ya est.
		

Ms que una vista de nivel superior
-----------------------------------

Hasta ahora, todos los procesos de negocio que has definido se muestran solo
en la vista de nivel superior. Quiz quieres tener ms de una vista de nivel
superior, p.e. porque tienes diferentes clientes y cada uno de ellos debera
ver solo sus procesos de negocio.

Solo debes ir al directorio etc y aadir ficheros de configuracin 
adicional, cada uno de ellos definiendo procesos de negocio como se describen
anteriormente.
Asumimos que los llamas
		nagios-bp-customer1.conf
		nagios-bp-customer2.conf
		nagios-bp-customer3.conf
		...
deben estar todos ubicados en el mismo directorio que nagios-bp.conf

Ahora usa las siguientes URLs para verlos:
		Para la vista de procesos de negocio:
		http://<servername>/nagiosbp/cgi-bin/nagios-bp.cgi?conf=nagios-bp-customer1
		http://<servername>/nagiosbp/cgi-bin/nagios-bp.cgi?conf=nagios-bp-customer2
		http://<servername>/nagiosbp/cgi-bin/nagios-bp.cgi?conf=nagios-bp-customer3
		...
		
		Y para el anlisis de impacto de negocio
		http://<servername>/nagiosbp/cgi-bin/nagios-bp.cgi?conf=nagios-bp-customer1&mode=bi
		http://<servername>/nagiosbp/cgi-bin/nagios-bp.cgi?conf=nagios-bp-customer2&mode=bi
		http://<servername>/nagiosbp/cgi-bin/nagios-bp.cgi?conf=nagios-bp-customer3&mode=bi
		...		
		
Ten en cuenta: Las diferentes configuraciones no se conocen entre si.
Por lo tanto no es posible usar un proceso de negocio definido en uno de ellos
en otra de las configuraciones.

Si quieres "mapear" el Proceso de Negocio de todos estos ficheros a servicios
de Nagios, usa

		/usr/local/nagiosbp/bin/bp_cfg2service_cfg.pl -f /usr/local/nagiosbp/etc/nagios-bp-customer1.conf
		/usr/local/nagiosbp/bin/bp_cfg2service_cfg.pl -f /usr/local/nagiosbp/etc/nagios-bp-customer2.conf
		/usr/local/nagiosbp/bin/bp_cfg2service_cfg.pl -f /usr/local/nagiosbp/etc/nagios-bp-customer3.conf

Quiz quieras diferentes plantillas por defecto para cada uno de estos ficheros
de configuracin, debido a que en un caso deben ser notificados los contactos del
cliente 1, en otro caso los contactos del cliente 2, ...

Para esto no necesitas incluir directivas de plantillas para cada Proceso de Negocio
unitario en cada fichero de configuracin unitario. Solo llama a bp_cfg2service_cfg.pl
con los parmetros -tt o -tm.
Puedes ver una descripcin completa
		bin/bp_cfg2service_cfg.pl --help


Donde se usa?
--------------

(caractersticas nuevas desde la versin 0.9.4)

Imagina que que quieres parar un servicio o un Host en tu red para realizar un mantenimiento
pero no eres el nico que intervino en la configuracin de ese equipo o servicio y
no ests seguro en cual de tus Procesos de negocio se usa.
Bien, puedes usar el interface web y hacer click en cada proceso de negocio y mirar
si est listado en este. Perders un montn de tiempo si tienes muchos procesos. Por
lo tanto te interesar usar esta caracterstica:

Puedes usar los parmetros "notes_url" o "action_url" de Nagios/Icinga para poner
la URL de "dondeSeUsa" (whereUsed-URL) en estos:

define host {
	# ...
	notes_url	/nagiosbp/cgi-bin/whereUsed.cgi?host=$HOSTNAME$
}

o

define host {
	# ...
	action_url	/nagiosbp/cgi-bin/whereUsed.cgi?host=$HOSTNAME$
}

en servicios:

define service {
	# ...
	notes_url	/nagiosbp/cgi-bin/whereUsed.cgi?host=$HOSTNAME$&service=$SERVICEDESC$
}

o

define service {
	# ...
	action_url	/nagiosbp/cgi-bin/whereUsed.cgi?host=$HOSTNAME$&service=$SERVICEDESC$
}

Estas definiciones funcionan para Nagios 3.x e Icinga. En el caso de que ests usando
Nagios 2.x, tendrs que definir las directivas notes_url o action_url en las secciones 
hostextinfo o serviceextinfo, no incluidas directamente en la seccin de host o servicio.

Probablemente ser mejor eleccin definir notes_url o action_url en una plantilla
p.e. en las plantillas genericas 'generic-host' o 'generic-service', de esta forma
estarn disponibles para todos tus hosts y sevicios.

Con estas definiciones obtendrs nuevos iconos en tu interface web Nagios/Icinga
para cada host y servicio. Cuando hagas un click en dichos iconos se mostrar una 
nueva vista mostrando en cual de tus procesos de negocio se usa dicho host o servicio.

Si tus notes_url y action_url ya se estn usando para otras cosas importantes como 
PnP y otros "Addons", tienes an otra opcin (la segunda mejor). Puedes definir
un enlace en el texto que ests obteniendo como "notes". (de nuevo, en Nagios 2.x 
tendrs que definir las directivas notes_url o action_url en las secciones hostextinfo o 
serviceextinfo).

define host {
	# ...
	notes	Ante problemas con este Host, ver la documentacin en el captulo 16.<br><a href="/nagiosbp/cgi-bin/whereUsed.cgi">donde se usa este Host?</a>
}

define service {
	# ...
	notes	Ante problemas con este Servicio, ver la documentacin en el captulo 16.<br><a href="/nagiosbp/cgi-bin/whereUsed.cgi">donde se usa este Servicio?</a>
}

La primera parte es la informacin normal para el servicio o host. Quiz definiste
ya esta parte para darle a los usuarios alguna informacin til en el interface web.

Luego puedes ver un <br> para nueva lnea y entonces un link con la sintaxis
HTML normal. Como podrs notar, no aadimos los parmetros host=$HOSTNAME$ y
service=$SERVICEDESC$ como hicimos anteriormente. Esto es porque Nagios/Icinga
no expanden macros aqu. Por lo tanto no necesitamos este cambio.
En lugar de eso, whereUsed.cgi busca el HTTP "referer" (el request en la cabecera
HTTP le dice de que URL viene el click) e intenta expandir la informacin acerca
de host y/o servicios de esta.

Esto funciona solamente cuando usamos el interface web oficial de Nagios/Icinga.
Cuando usemos algn otro interface probablemente no funcionar.

Tambin algunos usuarios configuran su navegador para sumprimir los HTTP "referers"
(para incrementar la privacidad) p.e. usando un plugin especial de Firefox. En este caso
tampoco funcionar.

En ambos casos ser mejor solucin usar action_url or notes_url.

Pisa adicional: Si 3 enlaces (uno en 'action_url', otro en 'notes_url' y otro en
'notes') no son suficientes para todo lo que quieras linkar a un simple host o
servicio, p.e. diferentes AddOns, un enlace a la documentacin de tu servidor y
dems, puedes aadir ms de un link en el texto pasado en la directiva 'notes'.


Donde se usa con ms de una vista de nivel superior (Top Level View)
--------------------------------------------------------------------

Si tienes ms de una vista de nivel superior (ver seccin al respecto anterior) y
quieres usar la funcionalidad Where_used?, por defecto el cgi 'whereUsed.cgi'
busca procesos en el fichero de configuracin por defecto nagios-bp.conf. Si 
quieres que busque en un fichero alternativo de configuracin, llamalo con el
parmetro adicional "conf", de la misma forma que se describi en la seccin
"Ms de una vista de nivel superior"

p.e.
	action_url	/nagiosbp/cgi-bin/whereUsed.cgi?conf=nagios-bp-customer1&host=$HOSTNAME$&service=$SERVICEDESC$
o
	notes		<a href="/nagiosbp/cgi-bin/whereUsed.cgi?conf=nagios-bp-customer1">Where is this service used?</a>

		
		
Cambios previos
---------------

Si haces cambios en tu fichero nagios-bp.conf, la nueva configuracin se usar
tan pronto como guardas el fichero. Todos tus clientes vern los cambios
inmediatamente.

Quiz no es esto lo que quieres. Quiz quieres chequear si todo est como lo 
has diseado y no hay errores en el fichero.

Entonces copia nagios-bp.conf a, p.e. nagios-bp-new.conf y realiza tus cambios a esta 
copia. Ahora sera buena idea hacer un chequeo de sintaxis de nagios-bp-new.conf como
se describe en la seccin chequeo de sintaxis.
Ahora puedes previsualizarlo tal como se describe en la seccin "Mas que una vista de
nivel superior"
Si todo est OK, copialo sobre nagios-bp.conf para tener tus cambios en linea.


Usando nuevos hosts o servicios en un Proceso de Negocio
--------------------------------------------------------

Si defines nuevos host o servicios en Nagios/Icinga y quieres usarlos en un
Proceso de Negocio, asegurate de recargar la configuracin de Nagios/Icinga
primero y adems esperar al menos un minuto. Esto le da a Nagios/Icinga tiempo
de escribir la informacin de estado inicial en el "backend" NDO o IDO (base de
datos NDO, base de datos IDO, ndo2fs, Merlin, mk_livestatus, ...). Ahora 
puedes usarlo. Ademas el chequeo de sintaxis (ver arriba, chequeo de sintaxis)
funcionar solo si la primera informacin de estado est disponible en el
"backend" NDO o IDO.


Cacheando resultados del "backend" NDO o IDO.
---------------------------------------------

(nueva caracterstica desde versin 0.9.4)

Si tienes problemas de rendimiento con el backend NDO o IDO que ests usando,
puede resultar en una latencia muy alta en tu instalacin de Nagios/Icinag.
Lo mejor en este caso en tunear tu backend NDO o IDO, p.e. tuneando MySQL o
decidiendo escribir ms o menos informacin en el backend NDO o IDO.

Solamente si esto es imposible o no cosnigues que tu sistema se tan rpido 
como requieres puedes pensar acerca de cachear valores en el "Nagios Business
Process AddOn" para un cierto intervalo de tiempo. Por tanto el acceso a IDO o
NDO no se realizar tan a menudo pero los resultados no sern tan actuales como
deberan.


El cache se guarda en un fichero en el sistema de ficheros, por defecto
		var/cache/ndo_backend_cache

Si decides finalmente usar el cach, activalo usando los parmetros cache_time
y cache_file en el fichero etc/ndo.cfg
(estn comentados en este)

Atencin , El instalador crea el fichero var/cache/ndo_backend_cache con permisos
para todo dios (666) . Si, por razones de seguridad, no lo quieres as, puedes
cambiar los permisos como quieras. Lo nico es que debes asegurarte que tanto el 
usuario bajo el que corre Nagios/Icinga como el usuario bajo el que corre Apache
tengan acceso de escritura en dicho fichero.


Adaptando el GUI a tus necesitades
----------------------------------

(nueva caracterstica desde la versin 0.9.5)

Algunos usuarios preguntaron sobre determinados cambios en el GUI.
La dificultad es que este AddOn se usa para muchos propsitos diferentes,
por lo tanto es imposible disear un GUI que se adapte a todos ellos.

Algunos lo usan para visualizarlo en una gran pantalla en un centro
de operaciones y con letras enormes que sean capaces de leerse desde gran
distancia. Otros lo usan en el navegador o en un telfono y necesitan
alguna vista compacta que no exiga hacer mucho scroll.

Algunos usan muchas prioridades mientras que otros solo necesitan una
prioridad (por lo tanto navegar entre prioridades no es necesario).

He decidido optar por una solucin genrica: por defecto se mantiene
el GUI como estaba porque pienso que ese aspecto est bien para la
mayora de usuarios.
Adems se le d a cada instalacin la posibilidad de cambiar el aspecto
del GUI para adaptarlo a necesidades especiales usadno sus propias CSS.

Todas las pginas incluyen un fichero CSS adicional llamado user.css.
Este es el que puedes cambiar. Todos los elementos relevantes en las
pginas HTML generadas tienen ahora un ID para que todo lo que puedas
hacer con CSS se pueda hacer con las pginas de Nagios Business Process.

Dicho fichero est en el directorio share/stylesheets/


algunos ejemplos:

Si quieres hacer el semforo "Trafficlight" legible desde una gran distancia,
solo aade la siguiente lnea en el fichero user.cdd
#nbp_trafficlight_yes_table td { border-top:30px solid white; padding:5px; font-size:120% }

Si no quieres ver los botones de seleccin para prioridades sencillas:
#nbp_prio_selection { display:none; }

De igual forma puedes ocultar tambin otros elementos.

Para visualiar el semforo ("traffic light") en el lado derecho, necesitas
dos lneas:
#nbp_cental_table_box_tl_yes { margin-right:9em; margin-left:0; }
#nbp_trafficlight_yes_box { float:right; }

Y estoy seguro de que los usuarios encontrarn muchos ms hacks chulos para
hacer que el GUI se adapte a sus necesidades . Si encuentras uno que piensas
que puede ser interesante tambin para otros usuarios, por favor mndamelo por
email a nagiosbp-users@lists.nagiosforge.org y lo publicar.

En la aproximacin descrita todos los usuarios de una instalacin obtienen
la misma apariencia para el GUI. Si quieres tener diferentes apariencias para
distintos usuarios estos pueden querer usar un addon para su navegador (como 
Stylish para Firefox) para aadir estilos especficos para usuarios directamente
en su navegador.

Es posible que quieras una aproximacin ms centralista: Podras crear ms de
un fichero user.css en el servidor. El problema es que todos los navegadores
preguntan por la misma URL de user.css. Pero puedes usar alguna caracterstica 
como mod_rewrite de Apache para decidir (p.e. por la direccin del cliente)
proporcinarles uno u otro fichero.

Traduccin: Javier Rubio.